Index: trunk/doc/ext/bouncer-networks.md
===================================================================
--- trunk/doc/ext/bouncer-networks.md	(revision 535)
+++ trunk/doc/ext/bouncer-networks.md	(revision 537)
@@ -28,7 +28,7 @@
 ## Description
 
-This document describes the `bouncer-networks` extension. This enables clients
-to discover servers that are bouncers, list and edit upstream networks the
-bouncer is connected to.
+This document describes the `soju.im/bouncer-networks` extension. This enables
+clients to discover servers that are bouncers, list and edit upstream networks
+the bouncer is connected to.
 
 Each network has a unique per-user ID called "netid". It MUST NOT change during
@@ -40,12 +40,13 @@
 ## Implementation
 
-The `bouncer-networks` extension defines a new `RPL_ISUPPORT` token and a new
-`BOUNCER` command.
-
-The `bouncer-networks` capability MUST be negociated. This allows the server and
-client to behave differently when the client is aware of the bouncer networks.
-
-The `bouncer-networks-notify` capability MAY be negociated. This allows the
-client to signal that it is capable of receiving and correctly processing
+The `soju.im/bouncer-networks` extension defines a new `RPL_ISUPPORT` token and
+a new `BOUNCER` command.
+
+The `soju.im/bouncer-networks` capability MUST be negociated. This allows the
+server and client to behave differently when the client is aware of the bouncer
+networks.
+
+The `soju.im/bouncer-networks-notify` capability MAY be negociated. This allows
+the client to signal that it is capable of receiving and correctly processing
 bouncer network notifications.
 
@@ -55,8 +56,8 @@
 Its optional value is the network ID bound for the current connection.
 
-### `bouncer-networks` batch
-
-The `bouncer-networks` batch does not take any parameter and can only contain
-`BOUNCER NETWORK` messages.
+### `soju.im/bouncer-networks` batch
+
+The `soju.im/bouncer-networks` batch does not take any parameter and can only
+contain `BOUNCER NETWORK` messages.
 
 ### `BOUNCER` command
@@ -80,6 +81,6 @@
     BOUNCER LISTNETWORKS
 
-The server replies with a `bouncer-networks` batch, containing any number of
-`BOUNCER NETWORK` messages:
+The server replies with a `soju.im/bouncer-networks` batch, containing any
+number of `BOUNCER NETWORK` messages:
 
     BOUNCER NETWORK <netid> <attributes>
@@ -135,15 +136,15 @@
 ### Network notifications
 
-If the client has negociated the `bouncer-networks-notify` capability, the
-server MUST send an initial batch of `BOUNCER NETWORK` messages with the current
-list of network, and MUST send notification messages whenever a network is
-added, updated or removed.
-
-If the client has not negociated the `bouncer-networks-notify` capability, the
-server MUST NOT send implicit `BOUNCER NETWORK` messages.
+If the client has negociated the `soju.im/bouncer-networks-notify` capability,
+the server MUST send an initial batch of `BOUNCER NETWORK` messages with the
+current list of network, and MUST send notification messages whenever a network
+is added, updated or removed.
+
+If the client has not negociated the `soju.im/bouncer-networks-notify`
+capability, the server MUST NOT send implicit `BOUNCER NETWORK` messages.
 
 When network attributes are updated, the bouncer MUST broadcast a
 `BOUNCER NETWORK` message with the updated attributes to all connected clients
-with the `bouncer-networks-notify` capability enabled:
+with the `soju.im/bouncer-networks-notify` capability enabled:
 
     BOUNCER NETWORK <netid> <attributes>
@@ -153,5 +154,5 @@
 When a network is removed, the bouncer MUST broadcast a `BOUNCER NETWORK`
 message with the special argument `*` to all connected clients with the
-`bouncer-networks-notify` capability enabled:
+`soju.im/bouncer-networks-notify` capability enabled:
 
     BOUNCER NETWORK <netid> *
@@ -251,6 +252,6 @@
     C: NICK emersion
     C: USER emersion 0 0 :Simon
-    S: CAP * LS :sasl=PLAIN bouncer-networks bouncer-networks-notify
-    C: CAP REQ :sasl bouncer-networks
+    S: CAP * LS :sasl=PLAIN soju.im/bouncer-networks soju.im/bouncer-networks-notify
+    C: CAP REQ :sasl soju.im/bouncer-networks
     [SASL authentication]
     C: BOUNCER BIND 42
@@ -260,5 +261,5 @@
 
     C: BOUNCER LISTNETWORKS
-    S: BATCH +asdf bouncer-networks
+    S: BATCH +asdf soju.im/bouncer-networks
     S: @batch=asdf BOUNCER NETWORK 42 name=Freenode;state=connected
     S: @batch=asdf BOUNCER NETWORK 43 name=My\sAwesome\sNetwork;state=disconnected